#ifndef LPOLY_H
#define LPOLY_H

/* Файл содержит интерфейс к функции для преобразования входного значения
   с помощью полинома в выходное значение.
   В данном заголовки описано только необходимое для применения готовых функций
   преобразования.

   В качестве готовых могут быть использованы функции получения темературы
   для различных типов термопар (thermocouples.h) и термосопротивлений (rtd.h).

   Для создания внешних функций преобразования нужны типы, описанные в lpoly_descr.h

   В проекте должен быть создан файл lpoly_config.h в котором определен тип
   t_lpoly_val, представляющий собой число с плавающей точкой заданной размерности
   (float или double) */

#include "lpoly_config.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Непразрачная структура, описывающая способ преобразования входного значения
   в выходное. Для применения в конечной программе внетреннее содержимое структуры
   не имеет значения, берется одна готовая структура и передается на вход
   lpoly_calc_val() */
struct st_lpoly_interval_descr;
typedef struct st_lpoly_interval_descr t_lpoly_interval_descr;

/* Функция вычисляющая по параметрам полинома и входному значению результирующее значение.
   Если в ok передан не нулевой указатель, то в данной переменной возвращается 1,
   если входное значение было успешно преобразовано и 0 - иначе (если выходит
   за диапазон, описываемый параметрами) */
t_lpoly_val lpoly_calc_val(const t_lpoly_interval_descr *descr, t_lpoly_val val, int *ok);

#ifdef __cplusplus
}
#endif

#endif // TEMP_CALC_H
